###############
##### Purpose:
### Call both datamanipulation files
### This will create exactly the data from the paper
### If you would like to make adjustments, like:
### Choosing a different country threshold
### Using scope 2 emissions
### Using a different tax base for the carbon tax
### Not trading the services sector ...
### Then you can make those choices in the two respective main files that this
### script is calling.
###############
rm(list=ls())

##Read packages
# Following function just checks if packages
# are installed; if yes it loads them, if not it installs and then loads them
using<-function(...) {
  libs<-unlist(list(...))
  req<-unlist(lapply(libs,require,character.only=TRUE))
  need<-libs[req==FALSE]
  if(length(need)>0){ 
    install.packages(need)
    lapply(need,require,character.only=TRUE)
  }
}

using("sjmisc","foreign","janitor","CoordinateCleaner","readxl",
      "xtable","tidyverse")
#################
#Set this to your folder. No other adjustments needed
#setwd("C:/Users/khsomme/Dropbox/Climate_Konstantin_Erhan/code/replication")
target_folder <- "/output_mat/output_mat_wiod_eora" #Name of folder,
# in which results are saved

source("./datamanipulation_scripts/manipulate/datamanip_main.R")
rm(list=ls())
target_folder <- "/output_mat/output_mat_wiod_eora" #Name of folder,
source("./datamanipulation_scripts/analysis/analysis_main.R")