%%%%%%
%Purpose: Make plots showing the total emissions 
% split by country group (based on who introduced taxes)
% before and after both simulations
% Need to adjust folder structure.
%%%%%%%
clear
%Chose:
cd 'C:/Users/wb614536/OneDrive - WBG/Documents/Reproducibility/20231205-outsourcing-environment-v2/replication/replication/'


%%Based on replication package structure
output_folder = 'Step3_plotting_output/output/bar_charts'
results_folder = 'data/results'
data_folder = 'data/data_mat'

%%%Standard setting, can be adjusted 
elasticity = "base";
data_name ='wiod_eora';
carb_producer_array = ["p" "q"];

for i=1:length(carb_producer_array)  
    carb_producer = carb_producer_array(i);
    %Plot size in cm
    x_width=15 ;
    y_width=10;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%From here on it runs
    % Read in data
    sim_name='tax'; %Not to chose; first do for tax then cbam
    filename=strcat(results_folder,'/res_',elasticity,'_',data_name,'_',sim_name,'.mat');
    load(filename);
    load(strcat(data_folder,'/data_mat_',data_name,'.mat'));
    A.tmp = 1:DC;
    %Chose:
    index_choice = index_ets;
    
    index_non_choice = A.tmp(~ismember(A.tmp, index_choice));
    if carb_producer=="q"
        rr=r_q;
    elseif carb_producer == "p"
        rr=r_p;
    end
    
    %%%%%%%%%%%%%%%%%%
    %% First calulate global change in E after tax increase
    %%%%
    E0=d.E0;
    TE0=d.TE0;
    CPIhat(1:DC,1)=prod(rr.Phihat.^gammaL,2);
    
    %
    E0_t = sum(sum(sum(E0,3),1),2);
    E0_t_choice = sum(sum(sum(E0(:,index_choice,:),3),1),2);
    E0_t_non_choice = sum(sum(sum(E0(:,index_non_choice,:),3),1),2);
    %
    Y0_t = sum(sum(sum(Y,3),1),2);
    Y0_t_choice = sum(sum(sum(Y(:,index_choice,:),3),1),2);
    Y0_t_non_choice = sum(sum(sum(Y(:,index_non_choice, :),3),1),2);
    %
    E1_tax = sum(sum(sum(E0.*rr.Ehat,3),1),2);
    E1_tax_choice = sum(sum(sum(E0(:,index_choice,:).* ...
        rr.Ehat(:,index_choice,:),3),1),2);
    E1_tax_non_choice = sum(sum(sum(E0(:,index_non_choice,:).*...
        rr.Ehat(:,index_non_choice,:),3),1),2);
    
    E_tax_change = E1_tax - E0_t;
    E_tax_change_choice = E1_tax_choice - E0_t_choice;
    E_tax_change_non_choice = E1_tax_non_choice - E0_t_non_choice;
    %
    Y1_tax_tot = sum(sum(Y.* rr.Yhat,3),1)'./CPIhat;
    Y1_tax = sum(Y1_tax_tot,1);
    Y1_tax_choice = sum(Y1_tax_tot(index_choice),1);
    Y1_tax_non_choice = sum(Y1_tax_tot(index_non_choice),1);
    
    Y_tax_change_choice = Y1_tax_choice - Y0_t_choice;
    Y_tax_change_non_choice = Y1_tax_non_choice - Y0_t_non_choice;
    
    %
    E_trans0 = rr.Etrans0;
    E_trans1_tax = rr.Etrans1;
    E_trans_change_tax = E_trans1_tax - E_trans0;
    
    %%%%%%%
    %% Now calulate global change in E after cbam scenario
    clear rr r_q r_p r_x;
    sim_name='cbam';
    filename=strcat(results_folder,'/res_',elasticity,'_',data_name,'_',sim_name,'.mat');
    load(filename);
    
    if carb_producer=="q"
        rr=r_q;
    elseif carb_producer == "p"
        rr=r_p;
    end
    CPIhat(1:DC,1)=prod(rr.Phihat.^gammaL,2);
    
    %%%
    E1_cbam = sum(sum(sum(E0.*rr.Ehat,3),1),2);
    E1_cbam_choice = sum(sum(sum(E0(:,index_choice,:).*...
        rr.Ehat(:,index_choice,:),3),1),2);
    E1_cbam_non_choice = sum(sum(sum(E0(:,index_non_choice,:).*...
        rr.Ehat(:,index_non_choice,:),3),1),2);
    
    E_cbam_change = E1_cbam - E0_t;
    E_cbam_change_choice = E1_cbam_choice - E0_t_choice;
    E_cbam_change_non_choice = E1_cbam_non_choice - E0_t_non_choice;
    %
    Y1_cbam_tot = sum(sum(Y.* rr.Yhat,3),1)'./CPIhat;
    Y1_cbam = sum(Y1_cbam_tot,1);
    Y1_cbam_choice = sum(Y1_cbam_tot(index_choice),1);
    Y1_cbam_non_choice = sum(Y1_cbam_tot(index_non_choice),1);
    
    Y_cbam_change_choice = Y1_cbam_choice - Y0_t_choice;
    Y_cbam_change_non_choice = Y1_cbam_non_choice - Y0_t_non_choice;
    
    %
    E_trans1_cbam = rr.Etrans1;
    E_trans_change_cbam = E_trans1_cbam - E_trans0;
    
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%Change export size
    set(gcf, 'PaperUnits', 'centimeters');
    set(gcf, 'PaperPosition', [0 0 x_width y_width]); %
    %% Now start plotting. First production emissions
    xlabel = categorical({'Pre','Tax','Tax & border tax'});
    vals_E = [E0_t_choice,E1_tax_choice,E1_cbam_choice;E0_t_non_choice,E1_tax_non_choice,E1_cbam_non_choice];
    plot_emi = bar(xlabel,vals_E);
    
    % Set the group names for the legend
    groupNames = {'EEA-EFTA', 'Other'};
    
    % Add a legend
    legend(plot_emi, groupNames,'Position', [0.7 0.5 0.2 0.2]); % [left bottom width height]
    % Set axis labels and title
    ylabel('Production emissions in million tonnes');
    title('Total production emissions before and after simulations');
    if carb_producer=="q"
        subtitle("keeping emissions supply constant")
    elseif carb_producer=="p"
        subtitle("Keeping emission prices constant")
    end
    % Get the numeric data
    data1 = plot_emi(1).YData;
    data2 = plot_emi(2).YData;
    
    % Create string labels with one decimal number
    labels1 = string(zeros(size(data1)));  % Preallocate the labels array
    labels2 = string(zeros(size(data2)));  % Preallocate the labels array
    
    for i = 1:numel(data1)
        labels1(i) = sprintf('%.1f', data1(i));
        labels2(i) = sprintf('%.1f', data2(i));
    end
    
    % Export the plot as a PNG file
    filename = strcat("emissions_",elasticity,'_',carb_producer,"_bar.png");
    saveas(gca,fullfile(output_folder, filename), 'png');
    
    
    %%%%%%%%%%%%%%%%%%%
    set(gcf, 'PaperPosition', [0 0 x_width y_width]); %
    %Now plot for transport vs production emissions
    xlabel = categorical({'Pre','Tax','Tax & border tax'});
    vals_E_trans = [E0_t,E1_tax,E1_cbam;E_trans0,E_trans1_tax,E_trans1_cbam];
    plot_trans_emi = bar(xlabel,vals_E_trans);
    % Set the group names for the legend
    groupNames = {'Production', 'Transportation'};
    
    % Add a legend
    legend(plot_trans_emi, groupNames,'Position', [0.685 0.2 0.2 0.2]);
    % [left bottom width height]
    % Set axis labels and title
    ylabel('Emissions in million tonnes');
    title('Production and transport emissions in both scenarios');
    if carb_producer=="q"
        subtitle("keeping emissions supply constant")
    elseif carb_producer=="p"
        subtitle("Keeping emission prices constant")
    end
    % Get the numeric data
    data1 = plot_trans_emi(1).YData;
    data2 = plot_trans_emi(2).YData;
    
    % Create string labels with one decimal number
    labels1 = string(zeros(size(data1)));  % Preallocate the labels array
    labels2 = string(zeros(size(data2)));  % Preallocate the labels array
    
    for i = 1:numel(data1)
        labels1(i) = sprintf('%.2e', data1(i));
        labels2(i) = sprintf('%.2e', data2(i));
    end
    
    
    % Export the plot as a PNG file
    filename = strcat("transport_emi_",elasticity,'_',carb_producer,"_bar.png");
    saveas(gca,fullfile(output_folder, filename), 'png')
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%
    set(gcf, 'PaperPosition', [0 0 x_width y_width]); %
    %% Now change plots: first emissions
    xlabel = categorical({'Tax','Tax & border tax'});
    vals_E_change = [E_tax_change_choice,E_tax_change_non_choice;E_cbam_change_choice,E_cbam_change_non_choice];
    plot_emi_change = bar(xlabel,vals_E_change);
    
    % Set the group names for the legend
    groupNames = {'EEA-EFTA', 'Other'};
    
    % Add a legend
    legend(plot_emi_change, groupNames,'Position', [0.7 0.2 0.2 0.2]);
    % Set axis labels and title
    ylabel('Change in production emissions in million tonnes');
    title('Change in production emissions from both scenarios');
    if carb_producer=="q"
        subtitle("keeping emissions supply constant")
    elseif carb_producer=="p"
        subtitle("Keeping emission prices constant")
    end
    % Get the numeric data
    data1 = plot_emi_change(1).YData;
    data2 = plot_emi_change(2).YData;
    
    % Create string labels with one decimal number
    labels1 = string(zeros(size(data1)));  % Preallocate the labels array
    labels2 = string(zeros(size(data2)));  % Preallocate the labels array
    
    for i = 1:numel(data1)
        labels1(i) = sprintf('%.1f', data1(i));
        labels2(i) = sprintf('%.1f', data2(i));
    end
    
    
    % Export the plot as a PNG file
    filename = strcat("emissions_changes_",elasticity,'_',carb_producer,"_bar.png");
    saveas(gca,fullfile(output_folder, filename), 'png');
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%
    set(gcf, 'PaperPosition', [0 0 x_width y_width]); %
    %% Now change plot: Transport emissions
    xlabel = categorical({'Tax','Tax & border tax'});
    vals_E_trans_change = [E_tax_change,E_cbam_change ;E_trans_change_tax,E_trans_change_cbam];
    plot_trans_emi_change = bar(xlabel,vals_E_change);
    
    % Set the group names for the legend
    groupNames = {'Production', 'Transportation'};
    
    % Add a legend
    legend(plot_trans_emi_change, groupNames,'Position', [0.685 0.2 0.2 0.2]); 
    % Set axis labels and title
    ylabel('Change in emissions in million tonnes');
    title('Change in production and transportation emissions from both scenarios');
    if carb_producer=="q"
        subtitle("Keeping emissions supply constant")
    elseif carb_producer=="p"
        subtitle("Keeping emission prices constant")
    end
    % Get the numeric data
    data1 = plot_trans_emi_change(1).YData;
    data2 = plot_trans_emi_change(2).YData;
    
    % Create string labels with one decimal number
    labels1 = string(zeros(size(data1)));  % Preallocate the labels array
    labels2 = string(zeros(size(data2)));  % Preallocate the labels array
    
    for i = 1:numel(data1)
        labels1(i) = sprintf('%.1f', data1(i));
        labels2(i) = sprintf('%.1f', data2(i));
    end
    
    
    % Export the plot as a PNG file
    filename = strcat("transport_emi_changes_",elasticity,'_',carb_producer,"_bar.png");
    saveas(gca,fullfile(output_folder, filename), 'png');
end