dir.create(paste("./data/",target_folder,"/E",sep=""), showWarnings = F)
#################################
#Emissions
#################################
### Take total emissions
df_eE <- df_ag_NT_E %>% 
  filter(sup_sector_harm == "CO2") %>% 
  select(-Country) %>% 
  pivot_longer(-c(sup_sector_harm),
               names_to = "country_sector",
               values_to = "Value") %>% 
  mutate(use_country = substr(country_sector,1,3),
         use_sector = substr(country_sector,5,nchar(country_sector))) %>% 
  pivot_wider(id_cols = c(use_country,use_sector),
              names_from = sup_sector_harm,
              values_from = Value) %>% 
  filter(use_sector != "final_use")

df_E <- df_eE %>% 
  pivot_wider(id_cols = use_country,
              names_from = use_sector,
              values_from = CO2) %>% 
  select(-use_country)

########################
dir.create(paste("./data/",target_folder,"/E",sep=""), showWarnings = F)
write.table(df_E,
            paste("./data/",target_folder,"/E/emissions.csv",sep=""),
            sep=",",
            row.names=FALSE, col.names = FALSE)