dir.create(paste("./data/",target_folder,"/psi",sep=""), showWarnings = F)
#################################
#psi^m
#################################
###### Choose between OECD or RFF carbon tax measure:
if (psi_choice == "oecd"){
  ### Get the total CO2 emissions derived above for alpha
  ### Get the total tax revenue of a country
  ### Divide one by the other --> get psi (= tax rate), but this is now done
  ### in file env_taxes
  
  df_psi <- read.delim(paste("./data/manipulated/",
                             file_name,
                             "env_tax.csv",
                             sep=""),
                       sep = ",") %>% 
    select(use_country,use_sector,tau) %>% 
    rename(psi = tau)
  years <- c(2004:2020)
  new_panel <- expand.grid(use_sector = unique(df_sectors$sup_sector_harm),
                           use_country = unique(df_countries$Country))
  
  # ###
  # #For the ones without data for now impose 0 psi
  # ###
  
  df_psi <-  merge(new_panel, df_psi, all.x = TRUE) %>%
    mutate(psi = replace(psi,
                         is.na(psi) | psi<0,
                         0)) %>% 
    filter(use_country %in% unique(df_countries$Country)) 
  df_psi_wide <- df_psi %>% 
    pivot_wider(names_from = use_sector,
                values_from = psi)
  
  write.table(select(df_psi_wide,-use_country),
              paste("./data/",target_folder,"/psi/psi.csv",sep=""),
              sep=",",
              row.names=FALSE, col.names = FALSE)
  
} else if (psi_choice == "rff"){
  library(countrycode)
  
  df_psi <- read.delim(
    "./data/raw/carbon_price/ecp_CO2.csv",
    sep=",") %>%
    select(jurisdiction,year,ecp_all_jurCO2_usd_k) %>%
    rename(psi = ecp_all_jurCO2_usd_k) 
  
  df_psi$Country <- suppressWarnings(countrycode(
    sourcevar = df_psi$jurisdiction,
    origin = "country.name",
    destination = "iso3c"))
  
  df_psi <- df_psi %>%
    filter(Country %in% df_countries_in_df,
           year == 2009) %>%
    select(-c(year,jurisdiction)) %>%
    distinct() #Drop duplicates
  
  ##Add countries w/o data  =0
  
  for (i in df_countries_in_df) {
    if (!(i %in% df_psi$Country)) {
      df_psi <- rbind(df_psi,
                      tibble(Country = i, psi = 0)) %>%
        arrange(Country)
    }
  }
  if (identical(df_countries_in_df,df_psi$Country) == FALSE) {
    stop("Alarm")
  }
  
  write.table(select(df_psi,psi),
              paste("./data/",target_folder,"/psi/psi.csv",sep=""),
              sep=",",
              row.names=FALSE, col.names = FALSE)
  
  
}