dir.create(paste("./data/",target_folder,"/epsilon",sep=""), showWarnings = F)
#################################
#epsilon_j^m
#################################
df_eps <- readRDS("./data/manipulated/alpha_e.rds") %>% 
  left_join(df_psi) %>% 
  group_by(use_country,use_sector) %>% 
  summarise(psi = mean(psi),
            CO2 = sum(CO2),
            imputed_GO = sum(imputed_GO),
            alpha_E = mean(alpha_E)) %>% 
  mutate(epsilon = CO2/(imputed_GO*alpha_E-CO2*psi)) %>%  #,
  #         epsilon = replace(epsilon,
  #                           epsilon<0,
  #                           0)) %>% 
  select(use_country,use_sector,epsilon) 

min_non_negative <- min(df_eps$epsilon[df_eps$epsilon >= 0])

df_eps <- df_eps %>% mutate(epsilon = replace(epsilon,
                                              epsilon<0,
                                              min_non_negative)) %>% 
  pivot_wider(names_from = use_sector,
              values_from = epsilon)

#### Export 

write.table(select(ungroup(df_eps),-c(use_country)),
            paste("./data/",target_folder,"/epsilon/epsilon.csv",sep = ""),
            sep=",",
            row.names=FALSE, col.names = FALSE)
