dir.create(paste("./data/",target_folder,"/gamma",sep=""), showWarnings = F)
#################################
#gamma 
#################################
### shares of sectors in final consumption of countries
### Only keep final use by providing sector
### Get total final use in a country. Divide sector by total --> gamma
df_gamma <- df_ag_NT %>% 
  group_by(sup_sector_harm) %>% 
  summarise(across(where(is.numeric),sum)) %>% 
  select(sup_sector_harm,
         ends_with("final_use")) %>% 
  filter(sup_sector_harm %in% trade_sectors | 
           sup_sector_harm == "NT") %>% 
  pivot_longer(-c(sup_sector_harm),
               names_to = "country_sector",
               values_to = "final_use") %>% 
  mutate(Country = substr(country_sector,1,3),
         country_sector = NULL) %>% 
  group_by(Country) %>% 
  mutate(total_final_use = sum(final_use)) %>% 
  ungroup() %>% 
  mutate(gamma = final_use/total_final_use) %>% 
  pivot_wider(id_cols  = Country,
              names_from = sup_sector_harm,
              values_from = gamma)

df_gamma <- df_gamma %>% 
  select(-c(Country))
write.table(df_gamma,paste("./data/",target_folder,"/gamma/gamma.csv",sep=""),
            sep=",",
            row.names=FALSE, col.names = FALSE)
