dir.create(paste("./data/",target_folder,"/gdp_pc",sep=""), showWarnings = F)
#################################
## Add country GDP per capita (newest data)
#################################
df_gdp_pc <- read.delim(
  "./data/raw/WB_GDP_pc/API_NY.GDP.PCAP.CD_DS2_en_csv_v2_4888903.csv",
  skip = 4,sep=",") %>% 
  select(c(Country.Code,X2021)) %>% 
  mutate(X2021 = X2021/1000000) %>%  #Convert into  Million USD
  filter(Country.Code %in% df_countries_in_df) 

#Find missing countries:
missing_count <- df_countries_in_df[!(df_countries_in_df %in% df_gdp_pc$Country.Code)]
##ROW and TWN

## Add as mean of all other in WIOD (for now)
sum_gdp <- summary(df_gdp_pc$X2021)

df_gdp_pc <- df_gdp_pc %>% 
  add_row(Country.Code =missing_count,
          X2021 = rep(sum_gdp["Mean"],
                      length(missing_count))) %>% 
  arrange(Country.Code) %>% 
  mutate(X2021 = replace(X2021,
                         is.na(X2021),
                         mean(X2021,na.rm=T)))



write.table(select(df_gdp_pc,X2021),
            paste("./data/",target_folder,"/gdp_pc/gdp_pc.csv",sep=""),
            sep=",",
            row.names=FALSE, col.names = FALSE)