dir.create(paste("./data/",target_folder,"/scc",sep=""), showWarnings = F)
#################################
#Social costs of carbon
#################################
## Mapping is based on Nordhaus2003, Table 3.1
country_mapping <- read.table(
  "./data/raw/country_mapping.csv",
  header = TRUE,
  sep=";",quote = "") %>% 
  mutate(
    Nordhaus = replace(Nordhaus,
                       Nordhaus %in% c("Europe","Americas", "Asia","Low Income"),
                       "Low income")
  ) %>% 
  rename(Country = alpha.3)

v_scj <- c(0.45,0.22,0.5,2.83,-0.65,4.93,-0.93,1.95,0.71,2.44,1.81,3.91,2.64)
scj_names <- c("United States" , "China", "Japan", "OECD Europe" , "Russia" ,
               "India","Other high income", "High income OPEC","Eastern Europe", 
               "Middle income" , "Lower middle income" , "Africa",  "Low income")

v_scj <- setNames(v_scj,scj_names)
dfscj <- df_ag_NT %>% 
  ungroup() %>% 
  select(Country) %>% 
  filter(Country != "TOT") %>% 
  unique() %>% 
  tibble() %>% 
  mutate(id = row_number()) %>% 
  relocate( id, .before = Country) %>% 
  left_join(select(country_mapping,Country,Nordhaus)) %>% 
  mutate(scj = v_scj[Nordhaus],
         scj = replace(scj,
                       is.na(scj), #Should be only ROW
                       mean(scj,na.rm=TRUE)))

write.table(select(dfscj,scj),
            paste("./data/",target_folder,"/scc/scc_i.csv",sep=""),
            sep=",",
            row.names=FALSE, col.names = FALSE)