dir.create(paste("./data/",target_folder,"/X",sep=""), showWarnings = F)
##################################
#Start Analysis: X matrices
##################################
### Compute trade matrix. Amount of j, produced in m, coming to n
### Be careful with NT and the bottom columns 

df_long <- df_ag_NT %>% 
  filter(Country != "TOT") %>% #Here now just excluding all adjustments
  pivot_longer(!c(Country,sup_sector_harm),#,
               names_to = "country_sector",
               values_to = "imports") %>% 
  mutate(imp_country = substr(country_sector,1,3),
         imp_sector = substr(country_sector,5,nchar(country_sector)))

df_imp_j_nm <- df_long %>% 
  group_by(Country,sup_sector_harm,imp_country) %>% 
  summarise(imp_j_nm = sum(imports))


####### 
df_t <-  df_imp_j_nm %>% 
  pivot_wider(id_cols = c(sup_sector_harm,imp_country), #Importer in row, exporter in column
              names_from = Country,
              values_from = imp_j_nm)

###
#Check trade ratio
# total_GDP <- df_t %>% ungroup() %>% 
#   summarise(across(where(is.numeric), sum)) %>% 
#   rowSums() 
# 
# diag_m <- df_t %>% 
#   pivot_longer(-c(sup_sector_harm,imp_country),
#                names_to = "exp_country",
#                values_to = "Value") %>% 
#   filter(imp_country==exp_country)
# 
# sum_diag <- diag_m %>% ungroup() %>% summarise(total = sum(Value))
# 
# (total_GDP - sum_diag)/total_GDP #Trade ratio (1-absorption)
#######
#Now in a loop always take one sector and extract that csv
#######
dir.create(paste("./data/",target_folder,"/X",sep=""), showWarnings = F)

i <- 1
for (sec in trade_sectors){
  
  df_t_r <- df_t %>% 
    filter(sup_sector_harm == sec) %>% 
    ungroup %>% 
    select(-c(sup_sector_harm,imp_country))
  
  write.table(df_t_r, paste("./data/",target_folder,"/X/X_",i,".csv",sep = ""),
              sep=",",
              row.names=FALSE, col.names = FALSE)
  i = i+1
}


##############
#Sector and country overview
##############
df_sectors <- df_ag_NT %>% 
  select(sup_sector_harm) %>% 
  filter(sup_sector_harm %in% trade_sectors |
           sup_sector_harm =="NT") %>% 
  unique() %>% 
  tibble() %>% 
  mutate(id = row_number(),
         sector_name = sector_names[sup_sector_harm]) %>% 
  relocate( id, .before = sup_sector_harm)
write.table(df_sectors, paste("./data/",target_folder,"/sectors.csv",sep=""),
            sep=",",
            row.names=FALSE, col.names = FALSE)

df_countries <- df_ag_NT %>% 
  ungroup() %>% 
  select(Country) %>% 
  filter(Country != "TOT") %>% 
  unique() %>% 
  tibble() %>% 
  mutate(id = row_number()) %>% 
  relocate( id, .before = Country)
write.table(df_countries, paste("./data/",target_folder,"/countries.csv",sep=""),
            sep=",",
            row.names=FALSE, col.names = FALSE)

######
#other
######
ref_index <- select(filter(df_countries, Country == reference_country),id)
df_other <- c(dim(df_countries)[1],length(final_sectors),ref_index)
write.table(df_other, paste("./data/",target_folder,"/other.csv",sep=""),
            sep=",",
            row.names=FALSE, col.names = FALSE)

#################################
#NT output
#################################
df_NT <- df_ag_NT %>% 
  filter(sup_sector_harm == "NT") %>% 
  ungroup() %>% 
  select(Country,ends_with("NT")) %>% 
  rename_all(~ str_remove(., "_NT")) 
df_NT <- df_NT %>% 
  pivot_longer(!c(Country),
               names_to = "Importer",
               values_to = "Trade_val") %>% ###Turn exporter and importer around
  pivot_wider(names_from = "Country",
              values_from = "Trade_val") %>% 
  select(-Importer)

write.table(df_NT,paste("./data/",target_folder,"/X/X_11.csv",sep=""),
            sep=",",
            row.names=FALSE, col.names = FALSE)  