dir.create(paste("./data/",target_folder,"/wL",sep=""), showWarnings = F)
#################################
#w*L
#################################
### Take data from EORA.
df_wL <- eora_VA %>% 
  filter(sup_sector_harm == "Compensation of employees D.1") %>% 
  pivot_longer(-c(sup_sector_harm),names_to = "country_sector",
               values_to = "Value") %>% 
  mutate(use_country = substr(country_sector,1,3),
         use_sector = substr(country_sector,5,nchar(country_sector))) %>% 
  mutate(df_count = if_else(use_country %in% df_countries_in_df,
                            use_country,
                            "ROW")) %>% 
  group_by(df_count,use_sector) %>% 
  summarise(Value = sum(Value)) %>% 
  pivot_wider(id_cols = df_count,
              names_from = use_sector,
              values_from = Value) %>% 
  ungroup() %>% 
  # Turn from 1000 USD into Million USD
  mutate(across(where(is.numeric),~ . /1000)) %>% 
  rename(use_country = df_count)

write.table(select(df_wL,-use_country),
            paste("./data/",target_folder,"/wL/wL.csv",sep=""),
            sep=",",
            row.names=FALSE, col.names = FALSE)