###############
##### Purpose:
### Run all datamanipulation files sequentially
###############
#rm(list=ls())

# ##Read packages
# library(readxl)
# library(tidyverse)
# library(sjmisc) # to rotate tibbles
# #################
# #Set this to your folder. No other adjustments needed
# setwd("C:/Users/khsomme/OneDrive - UvA/PhD/Worldbank/transport/analysis/replication")

#################
##Choices:
#################
#Only need to chose this one, the others below are optional
first_run <- 1 # Chose 1 if WIOD, EORA and E-prices not created before


###############################
###
# Should the NT or other sector be traded.
# FALSE if not --> NT, TRUE if yes --> other
###
trade_NT <- TRUE #Choose if Other sector (services etc.) should be traded or not
countries_eora_emissions <- c("LUX","ROU","NOR","HRV","CHE") #Which countries in WIOD need to have emissions from EORA


###Define country cutoff for EORA, either chose a number of countries in final data,
##or how big GDP of country needs to be in order to be included
cutoff_n <- 100 # How many countries to include
cutoff_va <- 5000000 # What GDP threshold to choose. Currently only this one used
cutoff_choice <- "va" #Chose va or n

### Chose name of data to be saved under (base on country threshold)
save_name <- "wiod_eora_5bn_"
###############
#Now do first data manipulations on raw data
if (first_run==1){
  dir.create("./data/manipulated/IO", showWarnings = F)
  ##EORA
  source("./datamanipulation_scripts/manipulate/adjust_eora.R")
  
  ##WIOD
  source("./datamanipulation_scripts/manipulate/adjust_wiod.R")
  
  ##E Prices
  source("./datamanipulation_scripts/manipulate/e_price_calculation.R")
  
}

##Put everything together
source("./datamanipulation_scripts/manipulate/wiod_eora.R")
