######################
## This file comprises mappings between the countries  and sectors 
## used in Cristea et al 2013 and our data
############################
sector_mapping <- c("Bulk Agriculture" ="A",
                    "Leather products"="C13-C15",
                    "Wood products"="C16-C18",
                    "Paper products, publishing"="C16-C18", 
                    "Petroleum, coal products"="C19-C23",
                    "Chemical, rubber, plastic products" = "C19-C23",
                    "Mineral products nec" = "C19-C23", 
                    "Ferrous metals" = "C24-C25",
                    "Metals nec" = "C24-C25", 
                    "Metal products" = "C24-C25",
                    "Motor vehicles and parts" = "C29-C30", 
                    "Processed Agriculture" = "C10-C12", 
                    "Transport equipment nec" = "C29-C30", 
                    "Electronic equipment" = "C26-C28", 
                    "Machinery and equipment nec" = "C26-C28", 
                    "Manufactures nec" = "C31-C33",
                    "Forestry" = "A", "Fishing" = "A", 
                    "Minerals" = "B", "Oil"= "B", "Gas"="B",
                    "Textiles" = "C13-C15", "Wearing apparel" = "C13-C15")

C_C_Amer <- data.frame(Country = c("BLZ", "AIA", "ATG", "ABW", "BHS",
                                   "BRB", "VGB", "CYM", "CUB", "DMA", "GRD",
                                   "HTI", "MSR", "ANT", "KNA", "LCA", "VCT",
                                   "TCA", "VIR","GTM","CRI","DOM","BMU","JAM","NIC","HND"),
                       origin = rep("C_C_Amer",26)) #done

E_Asia <-   data.frame(Country = c("PRK", "MAC", "MNG", "PHL", "THA",
                                   "VNM","BRN"),
                       origin = rep("E_Asia",7)) #Done

oceania <- data.frame(Country =  c("AUS", "FJI", "KIR", "MHL", "FSM", "NRU",
                                   "NZL", "PNG", "PLW", "SLB", 
                                   "TON", "TUV", "VUT", "WSM","NCL","PYF"),
                      origin = rep("Oceania",16)) #Done


EU27 <- data.frame(Country = c("CYP", "CZE", "EST", "HUN", "LVA", "LTU",
                               "MLT", "POL", "SVK", "SVN", "BGR", "ROU","LUX",
                               "SLV"),
                   origin = rep("EU27",14)) #Done

Mala_Indo <- data.frame(Country = c("MYS", "IDN"),
                        origin = rep("Mala_Indo",2)) #Done

MEAS_NAfr <- data.frame(Country = c( "MAR", "TUN","BHR",
                                     "DZA", "LBY", "ESH","ARE","EGY","IRN",
                                     "IRQ","ISR","JOR","KWT","LBN","QAT","SAU",
                                     "SYR","YEM","OMN","PSE"),
                        origin = rep("MEAS_NAfr",20)) #Done

Oth_CEE_CIS <- data.frame(Country = c("ALB", "HRV", "TUR","GEO",
                                      "TJK", "TKM", "UZB","AZE","UKR","KAZ","ARM"),
                          origin = rep("Oth_CEE_CIS",11)) #Done

Oth_Europe <- data.frame(Country = c("CHE", "ISL", "LIE", "NOR","SRB","BIH","MKD"),
                         origin = rep("Oth_Europe",7)) #Done

R_S_Asia <- data.frame(Country = c("AFG", "BTN", "MDV","PAK","LKA","BGD","NPL"),
                       origin = rep("R_S_Asia",7)) ##Done

CHIHKG <- data.frame(Country = c("CHN","HKG"),
                     origin = c( "CHIHKG","CHIHKG"))

R_SE_Asia <- data.frame(Country = c("MMR", "TLS","KHM"),
                        origin = rep("R_SE_Asia",3)) ##Done

S_o_Amer <- data.frame(Country = c( "COL", "PER", "URY","BOL",
                                    "VEN", "FLK", "GUF", "GUY", "SGS", "SUR",
                                    "ECU","PAN","PRY"),
                       origin = rep("S_o_Amer",13)) ##Done

S_S_AFR <- data.frame(Country = c("AGO", "COD", "ETH", "KEN", "MDG", "MWI",
                                  "MUS", "MOZ", "RWA", "TZA", "UGA", "ZMB",
                                  "ZWE", "BWA", "NAM", "GMB", "GNB", "LBR",
                                  "MLI", "MRT", "NER", "SHN", "SLE", "CAF",
                                  "TCD", "COG", "GNQ", "GAB", "STP","CIV","SEN",
                                  "LSO","SUD","GHA","TTO","NGA","CMR","BEN","BFA"),
                      origin = rep("S_S_AFR",39)) ##Done
ind_countries <-  c("GERMANY" = "DEU", "TAIWAN" = "TWN", "AUSTRIA" = "AUT", 
                    "SWEDEN" = "SWE", 
                    "KOREA" = "KOR", "FINLAND" = "FIN", "BRAZIL" = "BRA",
                    "CHILE" = "CHL", 
                    "SOUTHAFRICA" = "ZAF", "ARGENTINA" = "ARG",
                    "SINGAPORE" = "SGP", 
                    "CAN" = "CAN", "ITALY" = "ITA", "NETHERLANDS" = "NLD",
                    "BELGIUM" = "BEL", 
                    "FRANCE" = "FRA", "PORTUGAL" = "PRT", "DENMARK" = "DNK",
                    "USA" = "USA", 
                    "IRELAND" = "IRL", "MEXICO" = "MEX", "GREECE" = "GRC",
                    "RUSSIA" = "RUS", "Russia" = "RUS",
                    "UK" = "GBR", "INDIA" = "IND", "SPAIN" = "ESP",
                    "JAPAN" = "JPN")