######################
## This file creates vectors with country groupings
## There indices in the data can then be outputted and used for example
## in Matlab to make shocks specific to certain countries
############################

oecd_iso3 <- c("AUS", "AUT", "BEL", "CAN", "CHE", "CHL", "COL", "CZE", "DEU",
               "DNK", "ESP", "EST", "FIN", "FRA", "GRC", "HUN", "IRL", "ISL", 
               "ISR", "ITA", "JPN", "KOR", "LTU", "LUX", "LVA", "MEX", "NLD", 
               "NOR", "NZL", "POL", "PRT", "SVK", "SVN", "SWE", "TUR", "GBR", "USA")
eu27_iso3 <- c("AUT", "BEL", "BGR", "CYP", "CZE", "DEU", "DNK", "EST", "ESP",
               "FIN", "FRA", "GRC", "HRV", "HUN", "IRL", "ITA", "LTU", "LUX",
               "LVA", "MLT", "NLD", "POL", "PRT", "ROU", "SVK", "SVN", "SWE")
eu_ets <- c("AUT", "BEL", "BGR", "CHE","CYP", "CZE", "DEU", "DNK", "EST", "ESP",
            "FIN", "FRA", "GRC", "HRV", "HUN", "IRL","ISL", "ITA", "LTU", "LUX",
            "LVA", "MLT", "NLD","NOR", "POL", "PRT", "ROU", "SVK", "SVN", "SWE")
oecd_high_eu <- c("AUS","AUT", "BEL", "BGR","CAN", "CHE","CHL","CYP", "CZE",
                  "DEU", "DNK", "EST", "ESP",
            "FIN", "FRA","GBR", "GRC", "HRV", "HUN", "IRL","ISL","ISR", "ITA","JAP", 
            "KOR","LTU", "LUX",
            "LVA", "MLT", "NLD","NZL","NOR", "POL", "PRT", "ROU", "SVK", "SVN",
            "USA","SWE")

mercosur_iso3 <- c("ARG", "BRA", "PRY", "URY")

ssa_iso3 <- c("AGO", "BDI", "BEN", "BFA", "BWA", "CAF", "CIV", "CMR", "COD",
              "COG", "COM", "CPV", "DJI", "ERI", "ESH", "ETH", "GAB", "GHA",
              "GIN", "GMB", "GNB", "GNQ", "KEN", "LBR", "LSO", "MDG", "MLI",
              "MOZ", "MRT", "MUS", "MWI", "NAM", "NER", "NGA", "RWA", "SDN",
              "SEN", "SLE", "SOM", "SSD", "STP", "SWZ", "SYC", "TCD", "TGO",
              "TZA", "UGA", "ZAF", "ZMB", "ZWE")
north_africa_iso3 <- c("DZA", "EGY", "LBY", "MAR", "SDN", "TUN", "ESH")

europe_iso3 <- c("ALB", "AND", "AUT", "BLR", "BEL", "BIH", "BGR", "HRV", "CYP",
                 "CZE", "DNK", "EST", "FRO", "FIN", "FRA", "DEU", "GIB", "GRC",
                 "GGY", "HUN", "ISL", "IRL", "IMN", "ITA", "JEY", "KOS", "LVA",
                 "LIE", "LTU", "LUX", "MLT", "MDA", "MCO", "MNE", "NLD", "MKD", 
                 "NOR", "POL", "PRT", "ROU", "RUS", "SMR", "SRB", "SVK", "SVN", 
                 "ESP", "SWE", "CHE", "UKR", "GBR", "VAT")

############
##Only WIOD

# Europe
europe <- c("AUS", "AUT", "BEL", "BGR", "CHE", "CYP", "CZE", "DEU", "DNK", "ESP",
            "EST", "FIN", "FRA", "GBR", "GRC", "HRV", "HUN", "ITA", "LTU", "LUX",
            "LVA", "MLT", "NLD", "NOR", "POL", "PRT", "ROU", "RUS", "SVK", "SVN",
            "SWE", "TUR")

# North America
north_america <- c("CAN", "USA","MEX")

# Africa
africa <- c()

# Asia
asia <- c("CHN","IND","PHL","IDN","JPN","KOR","MYS","SGP","TWN","THA")

# Oceania
oceania <- c("AUS", "NZL")

# South America
south_america <- c("BRA")

country_groupings <- data.frame(Country = c(europe,
                        north_america,
                        asia,
                        oceania,
                        south_america,
                        oecd_iso3,
                        mercosur_iso3,
                        eu27_iso3,
                        eu_ets,
                        oecd_high_eu),
                  Region = c(rep("europe",length(europe)),
                        rep("north_america",length(north_america)),
                        rep("asia",length(asia)),
                        rep("oceania",length(oceania)),
                        rep("south_america",length(south_america)),
                        rep("oecd_iso3",length(oecd_iso3)),
                        rep("mercosur_iso3",length(mercosur_iso3)),
                        rep("eu27_iso3",length(eu27_iso3)),
                        rep("eu_ets",length(eu_ets)),
                        rep("oecd_high_eu",length(oecd_high_eu))
                        ) 
                  )
