##########################
## This file solely creates dictionaries that are used to merge 
## sector classifications in different data files
##########################
### Start with WIOD; old lists the original column names
# Create hashed dictionary between sectors
old <- c("A01", "A02","A03","B","C10-C12","C13-C15","C16","C17",
         "C18","C19","C20","C21","C22","C23","C24","C25",
         "C26","C27","C28","C29","C30","C31_C32","C33","D35",
         "E36","E37-E39","F","G45","G46","G47","H49","H50",
         "H51","H52","H53","I","J58","J59_J60","J61","J62_J63",
         "K64","K65","K66","L68","M69_M70","M71","M72","M73",
         "M74_M75","N","O84","P85","Q","R_S","T","U")
#Columns are numbered:
old_num <- c("1","2","3","4","5","6","7","8","9","10","11","12","13","14",
             "15","16","17","18","19","20","21","22","23","24","25","26",
             "27","28","29","30","31","32","33","34","35","36","37","38",
             "39","40","41","42","43","44","45","46","47","48","49","50",
             "51","52","53","54","55","56","57","58","59","60","61") 

##This comprises the final sector groupings
new_smallest <- c("A", "A","A","B","C10-C12","C13-C15","C16-C18","C16-C18",
                  "C16-C18","C19-C23","C19-C23","C19-C23","C19-C23",
                  "C19-C23","C24-C25","C24-C25",
                  "C26-C28","C26-C28","C26-C28","C29-C30","C29-C30",
                  "C31-C33","C31-C33","D-E",
                  "D-E","D-E","F","G","G","G","H","H",
                  "H","H","H","I","J","J","J","J",
                  "K-N","K-N","K-N","K-N","K-N","K-N","K-N","K-N","K-N",
                  "K-N","O","P-Q","P-Q","R-S","T","U")
new_smallest_num <- c("A", "A","A","B","C10-C12","C13-C15","C16-C18","C16-C18",
                      "C16-C18","C19-C23","C19-C23","C19-C23","C19-C23",
                      "C19-C23","C24-C25","C24-C25",
                      "C26-C28","C26-C28","C26-C28","C29-C30",
                      "C29-C30","C31-C33","C31-C33","D-E",
                      "D-E","D-E","F","G","G","G","H","H",
                      "H","H","H","I","J","J","J","J",
                      "K-N","K-N","K-N","K-N","K-N","K-N","K-N","K-N","K-N",
                      "K-N","O","P-Q","P-Q","R-S","T","U",
                      "final_use","final_use","final_use",
                      "cap_form","invent")

#############
## EORA
eora_labels_NT <- c("A","A","B","C10-C12","C13-C15",
                    "C16-C18","C19-C23","C24-C25",
                    "C26-C28","C29-C30","C31-C33","C31-C33","NT",
                    "NT","NT","NT","NT","NT","NT",
                    "NT","NT","NT","NT","NT","NT","NT","TOT")
new_smallest_ordered <- c("A","B","C10-C12","C13-C15",
                          "C16-C18","C19-C23","C24-C25",
                          "C26-C28","C29-C30","C31-C33","D-E",
                          "F","G","H",
                          "I","J","K-N","O","P-Q","R-S","T","U")
###These are groups of sectors
trade_sectors <- c("A","B","C10-C12","C13-C15",
                          "C16-C18","C19-C23","C24-C25",
                          "C26-C28","C29-C30","C31-C33")
non_traded_sectors <- c("D-E",
                        "F","G","H",
                        "I","J","K-N","O","P-Q","R-S","T","U")

final_sectors <- c("A","B","C10-C12","C13-C15",
                   "C16-C18","C19-C23","C24-C25",
                   "C26-C28","C29-C30","C31-C33","NT")

final_use_sectors <- c("A","B","C10-C12","C13-C15",
                   "C16-C18","C19-C23","C24-C25",
                   "C26-C28","C29-C30","C31-C33","final_use","NT")
#################################
##These comprise sector classifications for emissions data (satelite data)
old_emi <- c("secAtB","secC","sec15t16","sec17t18","sec19","sec20",   
             "sec21t22","sec23","sec24",
             "sec25","sec26","sec27t28","sec29","sec30t33",
             "sec34t35","sec36t37","secE","secF","sec50","sec51","sec52","secH",
             "sec60","sec61" ,"sec62","sec63","sec64","secJ","sec70","sec71t74",
             "secL","secM","secN","secO","secP","secQ","secTOT","FC_HH")

new_emi_smallest <- c("A", "B","C10-C12","C13-C15","C13-C15","C16-C18","C16-C18",
                      "C19-C23","C19-C23","C19-C23","C19-C23","C24-C25",
                      "C26-C28","C26-C28","C29-C30","C31-C33","D-E",
                      "F","G","G","G","I","H","H",
                      "H","H","J","K-N","K-N","K-N",
                      "O","P-Q","P-Q","R-S","T","U","TOT","FC_HH")
####Notes on smallest/Emission mapping
#Textiles and leather need to be aggregated in emission data
#Electronics and machinery is switched in emissions
#Waste treatment no emissions data, recycling treated as manufacturing repair

##########################################
## Sector classifications in EU data
old_eu <- c("A","A01","A02","A03","B","C","C10-C12","C13-C15","C16" , 
            "C17","C18","C19","C20","C21","C22","C23","C24","C25" ,
            "C26","C27","C28","C29","C30","C31_C32","C33","D","E","E36",
            "E37-E39","EP_HH","EP_NRES","F","G","G45","G46","G47","H",
            "H49","H50","H51","H52","H53","I","I-U","J58" ,
            "J59_J60","J61","J62_J63","K64","K65","K66","L","M69_M70","M71"  ,
            "M72","M73","M74_M75","N77","N78","N79","N80-N82","NAL","O",
            "P","Q86","Q87_Q88","R90-R92","R93","S94","S95","S96","T","U")

new_eu <- c("A","X","X","X","B","X","C10-C12","C13-C15","C16-C18" , 
            "C16-C18","C16-C18","C19-C23","C19-C23","C19-C23","C19-C23",
            "C19-C23","C24-C25","C24-C25" ,
            "C26-C28","C26-C28","C26-C28","C29-C30","C29-C30","C31-C33","C31-C33","D","E", "X",
            "X","X","X","F","G","X","X","X","H",
            "X","X","X","X","X","I","X","J" ,
            "J","J","J","K-N","K-N","K-N","K-N","K-N","K-N","K-N"  ,
            "K-N","K-N","K-N","K-N","K-N","K-N","K-N","O",
            "P-Q","P-Q","P-Q","R-S","R-S","R-S","R-S","R-S","T","U")
##Xs will be grouped into one later
new_eu_nt <- c("A","X","X","X","B","X","C10-C12","C13-C15","C16-C18" , 
            "C16-C18","C16-C18","C19-C23","C19-C23","C19-C23","C19-C23",
            "C19-C23","C24-C25","C24-C25" ,
            "C26-C28","C26-C28","C26-C28","C29-C30","C29-C30","C31-C33","C31-C33","NT","NT" , "NT",
            "NT","X","X","NT","NT","X","X","X","NT",
            "X","X","X","X","X","NT","X","NT" ,
            "NT","NT","NT","NT","NT","NT","NT","NT","NT","NT"  ,
            "NT","NT","NT","NT","NT","NT","NT","NT",
            "NT","NT","NT","NT","NT","NT","NT","NT","NT","NT")
#################
## For labels:
sector_names <- c("A" = "Agriculture", "B" = "Mining & Quarrying",
                  "C10-C12" = "Manufacture of food products, beverages and tobacco products",
                  "C13-C15" = "Manufacture of textiles, wearing apparel and leather products",
                  "C16-C18" = "Manufacture of wood (products), paper (products), and printing",
                  "C19-C23" = "Manufacture of coke and refined petroleum products, chemicals, pharmaceuticals, plastic and non-metallic minerals" ,
                  "C24-C25" = "Manufacture of basic and fabricated metals",
                  "C26-C28" = "Manufacture of computer, electrical equipment, and machinery",
                  "C29-C30" = "Manufacture of motor vehicles and other transport equipment",
                  "C31-C33" = "Manufacture of furniture, other manufacturing and repair and recycling",
                  "NT" = "Energy and Services")
sector_names_short <- c("A" = "Agriculture", "B" = "Mining & Quarrying",
                  "C10-C12" = "Food",
                  "C13-C15" = "Textiles",
                  "C16-C18" = "Wood and paper",
                  "C19-C23" = "Fuels, chemicals and minerals" ,
                  "C24-C25" = "Basic and fabricated metals",
                  "C26-C28" = "Electrical equipment, machinery",
                  "C29-C30" = "Vehicles, transport equipment",
                  "C31-C33" = "Furniture, repair, and other",
                  "NT" = "Services and other")