%MAIN SCRIPT
clear

for var3={'base','fl'}

    for var1={'wiod_eora'}%,'wiod'}
        

        for var2={'tax','cbam'}%,'zero','tax','cbam'

            data_name=string(var1)
            sim_name=string(var2)
            spec_name=string(var3)

            %LOAD DATA

            load(strcat('../data/data_mat/data_mat_',data_name,'.mat'));


            if strcmp(spec_name,'base')

                theta=4.6;
                varsig=1.37;
                varphi=1.86;
                nu=1.44;

            elseif strcmp(spec_name,'fl')

                theta=4.6;
                varsig=1.37;
                varphi=-0.374;%0.625;
                nu=1.44;

            end
            eps_=1e-2; %a small number for derivative

            % alphabarM(:)=0;
            % tmp1=alphabarE+alphabarL;
            % alphabarL=alphabarL./tmp1;
            % alphabarE=alphabarE./tmp1;

            %shocks or unchanged parameters
            s.aLhat=1; %wagehat
            s.aMhat=1; %costM
            s.aEhat=1; %costE
            s.psi0=psi0; %DCxDJ
            s.psi1=psi0; %DCxDJ
            s.kappa0=0.0*ones(DC,DC,DJ); %careful with the shape
            s.kappa1=0.0*ones(DC,DC,DJ);
            s.Epmul=1;
            s.tauhat=ones(DC,DC,DJ);


            d.Niter=5000;
            d.err_tol=10e-8;
            d.vectorize=1;
            d.rho=0.5;
            d.decay=0.0032;
            d.T=50;

            d.DC=DC;
            d.DJ=DJ;
            d.ref_country=ref_country;
            d.Xibar=Xibar;
            d.Yshare=Yshare;
            d.DbarL=DbarL;
            d.Dbar=Dbar;
            d.savings=(sum(sum(Y,3),1)'-sum(sum(Y,3),2))./(sum(sum(Y,3),1)');
            d.epsilonbar=0.0053*ones(DC,DJ); %abs(epsilonbar);
            d.alphabarL=alphabarL;
            d.alphabarE=alphabarE;
            d.alphabarM=alphabarM;
            d.betaM=betaM;
            d.gammaL=gammaL;
            d.gammaE=gammaE;
            d.gamma_sign=gamma_sign;
            d.pibar=pibar;
            d.theta=theta;
            d.nu=nu;
            d.varsig=varsig;
            d.varphi=varphi;
            d.E0=E0;
            d.TE0=TE0;
            d.Y=Y;

            d.vartheta=vartheta;
            d.Lbar=Lbar;

           


            %r = Solve_EK(s,d);
            %Take Numerical Derivative---------------------------

            %Left side
            s.Epmul=1-eps_;
            r=Solve_EK(s,d);
            Erev1_=r.Erevhat;
            Etot1_=r.Etothat;

            %Right side
            s.Epmul=1+eps_;
            r=Solve_EK(s,d);
            Erev2_=r.Erevhat;
            Etot2_=r.Etothat;

            MC_=(Erev2_-Erev1_)./(Etot2_-Etot1_)
            %End Numerical Derivative---------------------------

            %Setup the shock now--------------------------

            %INDX(1,:)=1:DC;
            INDX(1,:)=index_ets;

            OTHER=1:DC;
            %OTHER(INDX)=[];

            if strcmp(sim_name,'zero')

            elseif strcmp(sim_name,'tax')


                %%Generate a uniform carbon tax in INDEX countries, by sector
                %Find max psi among all INDX countries, by sector
                % and set that as uniform tax
                %Can choose here if we want to focus on carbon tax or CBAM
                %If tax, then change psi1, if CBAM then change psi0, if both then psi1
                sorted_indx_taxes = sort(s.psi0(INDX,:), 'descend');
                for i=INDX
                    s.psi1(i,:) = sorted_indx_taxes(1,:);
                end


            elseif strcmp(sim_name,'cbam')


                %%Generate a uniform carbon tax in INDEX countries, by sector
                %Find max psi among all INDX countries, by sector
                % and set that as uniform tax
                %Can choose here if we want to focus on carbon tax or CBAM
                %If tax, then change psi1, if CBAM then change psi0, if both then psi1
                sorted_indx_taxes = sort(s.psi0(INDX,:), 'descend');
                for i=INDX
                    s.psi1(i,:) = sorted_indx_taxes(1,:);
                end

                %s.psi1=s.psi0; %DCx1

                %Implement CBAM for countries in INDX by sector (say a carbon club)
                for n=INDX
                    for m=OTHER
                        %s.kappa1(n,m) = 0;
                        if n~=m
                            s.kappa1(n,m,:) = max([ s.psi1(n,:)-s.psi1(m,:) 0]);
                        end
                    end
                end

            end




            %End shock design--------------------------
            opt=optimset('Display','none','TolX',1e-4,'TolFun',1e-4,'MaxIter',10000);

            s.Epmul=1;
            r_p=Solve_EK(s,d);
            s_p=s;

            disp('find Q')
            [pmul,FVAL,EXITFLAG]=fsolve(@objf_solve,1,opt,s,d);
            s.Epmul=pmul;
            r_q=Solve_EK(s,d);
            s_q=s;
            s_q.exitflag=EXITFLAG;
            EXITFLAG

            disp('max Rev')
            [pmul,FVAL,EXITFLAG]=fsolve(@objf_diff,pmul,opt,s,d,MC_);
            s.Epmul=pmul;
            r_x=Solve_EK(s,d);
            s_x=s;
            s_x.exitflag=EXITFLAG;
            EXITFLAG

           


            filename1=strcat('../data/results/res_',spec_name,'_',data_name,'_',sim_name,'.mat');
            save(filename1, 'r_p','r_q','r_x','s_p','s_q','s_x','d' );

            clearvars -except var1 var2 var3

        end
    end
end
