clear

% data_name='wiod_eora';
% sim_name='tax';
for var3={'base','fl'}
for var1={'wiod_eora'}%{'wiod','wiod_eora'}
for var2={'tax','cbam'}

data_name=string(var1);
sim_name=string(var2);
spec_name=string(var3);

filename1=strcat('../data/results/res_',spec_name,'_',data_name,'_',sim_name,'.mat');
load(filename1);


DC=d.DC;
DJ=d.DJ;
ref_country=d.ref_country;

theta=d.theta;
varsig=d.varsig;
varphi=d.varphi;
nu=d.nu;

Xibar=d.Xibar;
Yshare=d.Yshare;
DbarL=d.DbarL;
Dbar=d.Dbar;
savings=d.savings;
%Sbar=d.Sbar;
alphabarL=d.alphabarL;
alphabarE=d.alphabarE;
alphabarM=d.alphabarM;
betaM=d.betaM;
gammaL=d.gammaL;
pibar=d.pibar;

E0=d.E0;
TE0=d.TE0;
vartheta=d.vartheta;
Lbar=d.Lbar;

%prepare some parameters with new dimensions
alphabarE_nmj = permute(repmat(d.alphabarE,1,1,DC),[3,1,2]);
alphabarM_nmj = permute(repmat(d.alphabarM,1,1,DC),[3,1,2]);
alphabarL_nmj = permute(repmat(d.alphabarL,1,1,DC),[3,1,2]);

for version_=1:3
    
if version_==1
    version='q';
    rr=r_q;
elseif version_==2
    version='p';
    rr=r_p;
elseif version_==3
    version='x';
    rr=r_x;
end

E0=d.E0;
TE0=d.TE0;
Y=d.Y;


mul_=ones(DC,DC)-eye(DC);

CPIhat(1:DC,1)=prod(rr.Phihat.^gammaL,2);

Welf(1:DC,1)=rr.welf;

Eprod(1:DC,1)=sum(sum(E0.*rr.Ehat,3),1)./sum(sum(E0,3),1);
Eexp(1:DC,1)=sum(sum(E0.*rr.Ehat,3).*mul_,1)./sum(sum(E0,3).*mul_,1);
Eimp(1:DC,1)=sum(sum(E0.*rr.Ehat,3).*mul_,2)./sum(sum(E0,3).*mul_,2);

Etrexp(1:DC,1)=sum(sum(TE0.*rr.That,3).*mul_,1)./sum(sum(TE0,3).*mul_,1);
Etrimp(1:DC,1)=sum(sum(TE0.*rr.That,3).*mul_,2)./sum(sum(TE0,3).*mul_,2);

Etot(1:DC,1)=sum(sum(E0.*rr.Ehat+TE0.*rr.That,3),1)./sum(sum(E0+TE0,3),1);
Etot0(1:DC,1)=sum(sum(E0,3),1)';
Etotexp(1:DC,1)=sum(sum(E0.*rr.Ehat+TE0.*rr.That,3).*mul_,1)./sum(sum(E0+TE0,3).*mul_,1);
Etotimp(1:DC,1)=sum(sum(E0.*rr.Ehat+TE0.*rr.That,3).*mul_,2)./sum(sum(E0+TE0,3).*mul_,2);

Ytot1(1:DC,1)=sum(sum(Y.*rr.Yhat,3),1)'; %Production only
Ytot0(1:DC,1)=sum(sum(Y,3),1)';  %Production only

Ytot(1:DC,1)=(Ytot1./Ytot0)./CPIhat;  %Production only

Trtot1(1:DC,1:DC)=sum(Y.*rr.Yhat,3); %Trade
Trtot0(1:DC,1:DC)=sum(Y,3);  %Trade

Trtot(1:DC,1:DC)=(Trtot1./Trtot0)./CPIhat;  %Trade

tmp1a=sum(sum(rr.alphahatM.*alphabarM_nmj.*rr.Yhat.*Y,3),1)./sum(sum(rr.Yhat.*Y,3),1);
tmp1b=sum(sum(alphabarM_nmj.*Y,3),1)./sum(sum(Y,3),1);
Outsrc(1:DC,1)=tmp1a./tmp1b;
clear tmp1a tmp1b;

tmp1a=sum(sum(rr.alphahatM.*alphabarM_nmj.*Y,3),1)./sum(sum(Y,3),1);
tmp1b=sum(sum(alphabarM_nmj.*Y,3),1)./sum(sum(Y,3),1);
Outsrc_fixY(1:DC,1)=tmp1a./tmp1b;
Outsrc_fixY_pp(1:DC,1)=tmp1a-tmp1b;
clear tmp1a tmp1b;

tmp1a=sum(sum(rr.alphahatM.*alphabarM_nmj.*rr.Yhat.*Y,3),1)-sum(sum(alphabarM_nmj.*Y,3),1);
tmp1b=sum(sum(rr.alphahatE.*alphabarE_nmj.*rr.Yhat.*Y,3),1)-sum(sum(alphabarE_nmj.*Y,3),1);
Leak_material(1:DC,1)=((abs(tmp1a)./(abs(tmp1a)+abs(tmp1b))));
clear tmp1a tmp1b;

tmp1a=sum(sum(rr.alphahatL.*alphabarL_nmj.*rr.Yhat.*Y,3),1)./sum(sum(rr.Yhat.*Y,3),1);
tmp1b=sum(sum(alphabarL_nmj.*Y,3),1)./sum(sum(Y,3),1);
Abatement(1:DC,1)=tmp1a./tmp1b;
clear tmp1a tmp1b;

tmp1a=sum(sum(rr.alphahatL.*alphabarL_nmj.*Y,3),1)./sum(sum(Y,3),1);
tmp1b=sum(sum(alphabarL_nmj.*Y,3),1)./sum(sum(Y,3),1);
Abatement_fixY(1:DC,1)=tmp1a./tmp1b;
clear tmp1a tmp1b;

tmp1a=sum(sum(rr.alphahatE.*alphabarE_nmj.*Y,3),1)./sum(sum(Y,3),1);
tmp1b=sum(sum(alphabarE_nmj.*Y,3),1)./sum(sum(Y,3),1);
E_input_fixY(1:DC,1)=tmp1a./tmp1b;
clear tmp1a tmp1b;

tmp2a(1:DC,1)=sum(sum(rr.Ehat.*d.E0 - d.E0,3).*mul_,1); %export
tmp2b(1:DC,1)=sum(sum(rr.Ehat.*d.E0 - d.E0,3).*mul_,2); %import
tmp2c(1:DC,1)=sum(sum(rr.Ehat.*d.E0 - d.E0,3).*eye(DC),1); %diag

Leak_trade(1:DC,1:3)=[tmp2a tmp2b tmp2c];

%tmp2a(1:DC,1)=sum(sum(alphabarE_nmj.*rr.alphahatE.*(rr.Yhat./rr.xihat).*d.E0 - d.E0,3),1);

%tmp2b=zeros(DC,1);
% for n=1
%     
%     for m=1:DC
%         m
%         for j=1:DJ
%             for j2=1:DJ
%                 for m2=1:DC
% 
%                tmp2b(m,1) = tmp2b(m,1) +   sum(alphabarM_nmj(:,m,j).*(rr.alphahatM(:,m,j)-1))*(d.betaM(m,j,j2)*rr.pihat(m,m2,j2)*d.pibar(m,m2,j2)*rr.alphahatE(m,m2,j2)*alphabarE_nmj(m,m2,j2) )*rr.Ehat(m,m2,j2)*d.E0(m,m2,j2);
% 
%             end
%         end
%         end
%     end
% end



% tmp2b(1:DC,1)=sum(sum(alphabarE_nmj.*rr.alphahatET.*(rr.Yhat./rr.xihat).*d.E0 - d.E0,3),2);


Wageincome=rr.What./CPIhat;

L1 = (Lbar .* rr.Lhat)./CPIhat;
Incomedispersion0 =  std(Lbar, 0, 2);
Incomedispersion1 =  std(L1, 0, 2);
Incomedispersionhat = Incomedispersion1./Incomedispersion0;

%Get total exports per country
delta = ones(DC,DC) - eye(DC);

Ynm1 = delta .* sum(rr.Yhat.*Y,3); %Total trade after shock, Get rid of absorption
K1 = sum(Ynm1,1)./(CPIhat.'); %Sum over all export destinations
%K1_cbam_countries = sum(Ynm1(index_ets,:),1)./(CPIhat(index_ets,:).');

Ynm0 = delta .* sum(Y,3);
K0 = sum(Ynm0,1);

Exphat = (K1 ./ K0).'; %Change in exports. Now exporter in row (for maps)
%-------------------------------

foldername=strcat('../data/results_csv/res_',spec_name,'_',data_name,'_',sim_name,'/');
mkdir(foldername)

filename=strcat(foldername,version,'_Etot.csv');
writematrix(Etot,filename)

filename=strcat(foldername,version,'_Etotexp.csv');
writematrix(Etotexp,filename)

filename=strcat(foldername,version,'_Etotimp.csv');
writematrix(Etotimp,filename)

filename=strcat(foldername,version,'_Etrexp.csv');
writematrix(Etrexp,filename)

filename=strcat(foldername,version,'_Etrimp.csv');
writematrix(Etrimp,filename)

filename=strcat(foldername,version,'_Eexp.csv');
writematrix(Eexp,filename)

filename=strcat(foldername,version,'_Eimp.csv');
writematrix(Eimp,filename)

filename=strcat(foldername,version,'_Eprod.csv');
writematrix(Eprod,filename)

filename=strcat(foldername,version,'_Ytot.csv');
writematrix(Ytot,filename)

filename=strcat(foldername,version,'_Outsrc.csv');
writematrix(Outsrc,filename)

filename=strcat(foldername,version,'_Abatement.csv');
writematrix(Abatement,filename)

filename=strcat(foldername,version,'_Outsrc_fixY.csv');
writematrix(Outsrc_fixY,filename)

filename=strcat(foldername,version,'_Outsrc_fixY_pp.csv');
writematrix(Outsrc_fixY_pp,filename)

filename=strcat(foldername,version,'_Abatement_fixY.csv');
writematrix(Abatement_fixY,filename)

filename=strcat(foldername,version,'_E_input_fixY.csv');
writematrix(E_input_fixY,filename)

filename=strcat(foldername,version,'_Leak.csv');
writematrix(Leak_material,filename)

filename=strcat(foldername,version,'_Leak_trade.csv');
writematrix(Leak_trade,filename)

filename=strcat(foldername,version,'_Wageincome.csv');
writematrix(Wageincome,filename)

filename=strcat(foldername,version,'_Exphat.csv');
writematrix(Exphat,filename)

filename=strcat(foldername,version,'_Welf.csv');
writematrix(Welf,filename)

filename=strcat(foldername,version,'_Incomedispersionhat.csv');
writematrix(Incomedispersionhat,filename)

filename=strcat(foldername,'Etot0.csv');
writematrix(Etot0,filename)

filename=strcat(foldername,'Ytot0.csv');
writematrix(Ytot0,filename)

end

clearvars -except var1 var2 var3


end
end
end
