%THIS IS THE MAIN FUNCTION FOR SOLUTION (SCRIPT AS WE DEBUG)

function r = Solve_EK(s,d)

DC=d.DC;
DJ=d.DJ;
ref_country=d.ref_country;

%SHOCK
aLhat=s.aLhat; %wagehat productivity shocks
aMhat=s.aMhat; %costMhat productivity shocks
aEhat=s.aEhat; %costEhat productivity shocks
psi0=permute(repmat(s.psi0,1,1,DC),[3,1,2]); %n_ m j
psi1=permute(repmat(s.psi1,1,1,DC),[3,1,2]); %n_ m j
epsilonbar=permute(repmat(d.epsilonbar,1,1,DC),[3,1,2]); %n_ m j
kappa0=s.kappa0; %n m j
kappa1=s.kappa1; %n m j
tauhat=s.tauhat;
Epmul=s.Epmul;


%PARAMETERS AND SHARES
Niter=d.Niter;
err_tol=d.err_tol;
vectorize=d.vectorize;



theta=d.theta;
varsig=d.varsig;
varphi=d.varphi;
nu=d.nu;

Xibar=d.Xibar;
Yshare=d.Yshare;
Y=d.Y;
DbarL=d.DbarL;
Dbar=d.Dbar;
savings=d.savings;
%Sbar=d.Sbar;
alphabarL=d.alphabarL; %Note that this is different from model it is WageBill/TotalCost
alphabarE=d.alphabarE; %Note that this is different from model it is CarbonCost/TotalCost
alphabarM=d.alphabarM;
betaM=d.betaM;
gammaL=d.gammaL;
gammaE=d.gammaE;
gamma_sign=d.gamma_sign;
pibar=d.pibar;

E0=d.E0;
TE0=d.TE0;
vartheta=d.vartheta;
Lbar=d.Lbar;


%clear d s

%small number
eps=1e-20;

%speed variables
rho1=d.rho*0.5;
rho2=d.rho;
rho3=d.rho;
rho4=d.rho;


%prepare some parameters with new dimensions
alphabarL_nmj_ = permute(repmat(alphabarL,1,1,DC),[3,1,2]);
alphabarE_nmj_ = permute(repmat(alphabarE,1,1,DC),[3,1,2]);
alphabarM_nmj_ = permute(repmat(alphabarM,1,1,DC),[3,1,2]);

alphabarLx_nmj= alphabarL_nmj_./(alphabarL_nmj_+alphabarE_nmj_);
alphabarEx_nmj= alphabarE_nmj_./(alphabarL_nmj_+alphabarE_nmj_);


alphabarLam_nmj=(alphabarL_nmj_+alphabarE_nmj_)./(alphabarL_nmj_+alphabarE_nmj_+alphabarM_nmj_);
alphabarM_nmj=(alphabarM_nmj_)./(alphabarL_nmj_+alphabarE_nmj_+alphabarM_nmj_);



%step 0, guess
Yhat=(ones(DC,DC,DJ));
costMhat=(ones(DC,DJ));
wagehat=(ones(DC,DJ));
costEhat=(ones(DC,DC,DJ));

%allocate space
Yhat_star=(ones(DC,DC,DJ));
costMhat_star=(ones(DC,DJ));
wagehat_star=(ones(DC,DJ));
costEhat_star=(ones(DC,DC,DJ));


iter=0;
err_big=true;

while (iter < Niter && err_big )

    iter=iter+1;


    %Step 1, prices
    comp_0 = tauhat;

    comp_1 = permute( repmat(aLhat.*wagehat,1,1,DC),[3,1,2]); %n m j (variation over m j)
    comp_2 = aEhat.*costEhat;
    comp_3 = permute( repmat(aMhat.*costMhat,1,1,DC),[3,1,2]); %n m j (variation over m j)

    %costhat = (alphabarG_nmj.*(comp_1.^(-varsig)) + alphabarE_nmj.*(comp_2.^(-varsig)) + alphabarM_nmj.*(comp_3.^(-varsig))).^(-1/varsig);
    
    costhatLam = (alphabarLx_nmj.*(comp_1.^(-varphi)) + alphabarEx_nmj.*(comp_2.^(-varphi)) ).^(-1/varphi);

    costhat = (alphabarLam_nmj.*(costhatLam.^(-varsig)) + alphabarM_nmj.*(comp_3.^(-varsig))).^(-1/varsig);

    

    %Step 2, change in factor use
    alphahatLam = (costhatLam./costhat).^(-varsig);
    alphahatM = (comp_3./costhat).^(-varsig);

    alphahatL = ((comp_1./costhatLam).^(-varphi)).*alphahatLam;
    alphahatE = ((comp_2./costhatLam).^(-varphi)).*alphahatLam ;
    

    %Step 3,
    pnmjhat= comp_0.*costhat; %price incluging tariffs
    Phihat_nmj = ( sum( pibar.*(pnmjhat.^(-theta)) ,2 ) ).^(-(1/theta)); %n m j (variation over n j)
    Phihat = permute(Phihat_nmj,[1,3,2]); %n j

    %Step 4
    pihat = ( pnmjhat./Phihat_nmj ).^(-theta); %n j

    %Step 5
    What = ( sum( Lbar.*(wagehat.^nu),2 ) ).^(1/nu); %n j (variation over n)

    %Step 6
    Lhat= (wagehat./What).^(nu);


    %Step 7
    costMhat_star = prod( (permute(repmat(Phihat,1,1,DJ),[1,3,2])).^betaM,3); % n j from n j k (variation over k n), double-checked

    %clear Phihat_nmj

    %Step 8, calculate wage
    %wagehat_star=permute(sum(sum(Sbar.*Yhat.*alphahatL,1),3),[2,1,3]);
    %wagehat_star=wagehat_star/wagehat_star(ref_country,DJ); %NORMALIZE WITH ref_country WAGE

    wagehat_star=permute(sum(Xibar.*Yhat.*alphahatL,1),[2,3,1]).*( Lhat.^(-(nu-1)./nu));
    ref_price=prod(Phihat(ref_country,:).^gammaL(ref_country,:));
    wagehat_star=wagehat_star./ref_price; %NORMALIZE WITH ref_country WAGE


    %Step 9, calculate emissions (important step, need data first)
    Ehat=alphahatE.*(Yhat./costEhat);
    That=Yhat./pnmjhat;


    %Step 10, calculate carbon cost
    pricehat_E =ref_price.*Epmul;
    costEhat_star(:,:,:)= (pricehat_E + epsilonbar.*(psi1 + kappa1))./(1 + epsilonbar.*(psi0 + kappa0)); %constant in USD, note broadcasting in dim3
    

    %Step 11, Calculate tax revenue
    Rtax1=permute(sum(sum(psi1.*Ehat.*E0,1),3),[2,1,3]) +  sum(sum(kappa1.*Ehat.*E0,2),3) ;
    Rtax0=permute(sum(sum(psi0.*E0,1),3),[2,1,3]) +  sum(sum(kappa0.*E0,2),3) ;
    Rtaxhat = (Rtax1+eps)./(Rtax0+eps);

    %Step 12, Yhat
    incomehat = What.*(1-vartheta) + Rtaxhat.*vartheta ;
    expenditurehat = (incomehat - savings)./(1-savings); %constant trade defecit in nominal terms



    %VECTORIZED VERSION

    pihat_ = permute(repmat(pihat,1,1,1,DJ),[1,2,4,3]); %n m j_ k (variation over k n m)
    expenditurehat_ = repmat(expenditurehat,1,DC,DJ); %n m_ j (variation over n only)

    comp_6 = DbarL(:,:,:).*expenditurehat_.*pihat; % n m j  (j-->k)

    comp_7 = repmat(permute(sum(Xibar.*alphahatM.*Yhat,1),[2,1,3]),1,1,1,DJ); %n m_ j k_ (variation n and j)
    comp_8 = permute( sum( Dbar(:,:,1:DJ,:).*pihat_.*comp_7 , 3), [1, 2, 4, 3]); %n m j (j-->k) ;

    Yhat_star = comp_6+comp_8;

    %clear phihat_ incomehat_




    %Step 13
    err1= sum( abs(Yhat_star(:) - Yhat(:)).*Xibar(:) );
    err2= sum( abs(costMhat_star(:) - costMhat(:)) );
    err3= sum( abs(wagehat_star(:) - wagehat(:)) );
    err4= sum( abs(costEhat_star(:) - costEhat(:)) );

    Yhat = rho1*Yhat_star + (1-rho1)*Yhat;
    costMhat = rho2*costMhat_star + (1-rho2)*costMhat;
    wagehat = rho3*wagehat_star + (1-rho3)*wagehat;
    costEhat = rho4*costEhat_star + (1-rho4)*costEhat;


    %Step 14
    if mod(iter,50)==0
        err=[err1 err2 err3 err4];
        %disp(err)
        err_big=(err1 > err_tol || err2 > err_tol || err3 > err_tol || err4 > err_tol);
    end

end %while

CPIhat(1:DC,1)=prod(Phihat.^gammaL,2);

Eprod1=sum(sum(sum(E0.*Ehat)));
Eprod0=sum(sum(sum(E0)));

Etrans1=sum(sum(sum(TE0.*That)));
Etrans0=sum(sum(sum(TE0)));

Etot1=Eprod1+Etrans1;
Etot0=Eprod0+Etrans0;

r.Etothat=Etot1./Etot0;
r.Erevhat=(Etot1./Etot0).*Epmul;

r.Etrans0=Etrans0;
r.Etrans1=Etrans1;
r.Eprod0=Eprod0;
r.Eprod1=Eprod1;

r.EUhat= ((1 + (Etot1./gammaE).^2 ).^gamma_sign)./((1 + (Etot0./gammaE).^2 ).^gamma_sign);
Ytot1=sum(sum(Y.*Yhat,3),1)';
Ytot0=sum(sum(Y,3),1)';
Ytothat=Ytot1./Ytot0;
r.welf=(Ytothat./CPIhat).*r.EUhat;

r.Yhat=Yhat; %Output
r.wagehat=wagehat; %Wages
r.Lhat=Lhat; %Labor allocation
r.What=What; %Income (wage bill)
r.costMhat=costMhat; %Cost of carbon
r.costEhat=costEhat; %Cost of inputs (tasks)
r.pihat=pihat; %Import share

r.alphahatL=alphahatL; %Ratio of labor in total
r.alphahatM=alphahatM; %Ratio of input in total
r.alphahatE=alphahatE; %Ratio of carbon in total
r.alphahatLam=alphahatLam; %Ratio of LE bundle

% r.alphahatMT=alphahatM; %Ratio of input in total (already)
% r.alphahatLT=alphahatLam.*alphahatL; %Ratio of labor in total
% r.alphahatET=alphahatLam.*alphahatE; %Ratio of labor in total

r.Phihat=Phihat; %Price index for consumets
r.costhat=costhat; %Total production cost
r.pnmjhat=pnmjhat;  %Price faced by importers
r.Ehat=Ehat; %Emissions
r.That=That; %Transport emissions
r.Rtaxhat=Rtaxhat; %Tax revenue
r.incomehat=incomehat; %Disposable income
r.expenditurehat=expenditurehat; %expenditure
r.pricehat_E=pricehat_E; %Carbon price
r.CPIhat=CPIhat;
r.err=err; %final error
r.iter=iter; %number of iters